PLDAPStructBase Class Reference

`#include <pldap.h>`

Inheritance diagram for PLDAPStructBase:

## Public Member Functions

void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
PINDEX | GetNumAttributes () const
PLDAPAttributeBase & | GetAttribute (PINDEX idx) const
PLDAPAttributeBase * | GetAttribute (const char *name) const
void | AddAttribute (PLDAPAttributeBase *var)
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Static Public Member Functions

static PLDAPStructBase & | GetInitialiser ()
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...

## Protected Member Functions

| PLDAPStructBase ()
PLDAPStructBase & | operator= (const PLDAPStructBase &)
PLDAPStructBase & | operator= (const PStringArray &array)
PLDAPStructBase & | operator= (const PStringToString &dict)
void | EndConstructor ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

PDictionary< PString, PLDAPAttributeBase > | attributes
PLDAPStructBase * | initialiserStack

## Static Protected Attributes

static PMutex | initialiserMutex
static PLDAPStructBase * | initialiserInstance

## Additional Inherited Members

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...

## Constructor & Destructor Documentation

## PLDAPStructBase()

PLDAPStructBase::PLDAPStructBase | ( |  | ) |

protected

## Member Function Documentation

## AddAttribute()

void PLDAPStructBase::AddAttribute | ( | PLDAPAttributeBase * | var | ) |

## EndConstructor()

void PLDAPStructBase::EndConstructor | ( |  | ) |

protected

## GetAttribute() [1/2]

PLDAPAttributeBase& PLDAPStructBase::GetAttribute | ( | PINDEX | idx | ) | const

inline

## GetAttribute() [2/2]

PLDAPAttributeBase* PLDAPStructBase::GetAttribute | ( | const char * | name | ) | const

inline

## GetInitialiser()

static PLDAPStructBase& PLDAPStructBase::GetInitialiser | ( |  | ) |

inline static

References PAssertNULL.

## GetNumAttributes()

PINDEX PLDAPStructBase::GetNumAttributes | ( |  | ) | const

inline

## operator=() [1/3]

PLDAPStructBase& PLDAPStructBase::operator= | ( | const PLDAPStructBase & |  | ) |

protected

## operator=() [2/3]

PLDAPStructBase& PLDAPStructBase::operator= | ( | const PStringArray & | array | ) |

protected

## operator=() [3/3]

PLDAPStructBase& PLDAPStructBase::operator= | ( | const PStringToString & | dict | ) |

protected

## PrintOn()

void PLDAPStructBase::PrintOn | ( | ostream & | strm | ) | const

virtual

Output the contents of the object to the stream.

The exact output is dependent on the exact semantics of the descendent class. This is primarily used by the standard `operator<<` function.

The default behaviour is to print the class name.

Reimplemented from PObject.

## Member Data Documentation

## attributes

PDictionary<PString, PLDAPAttributeBase> PLDAPStructBase::attributes

protected

## initialiserInstance

PLDAPStructBase* PLDAPStructBase::initialiserInstance

static protected

## initialiserMutex

PMutex PLDAPStructBase::initialiserMutex

static protected

## initialiserStack

PLDAPStructBase* PLDAPStructBase::initialiserStack

protected

The documentation for this class was generated from the following file:

- pldap.h